Orxonox: orxonox::Camera Class Reference

# orxonox::Camera Class Reference

`#include <src/orxonox/objects/worldentities/Camera.h>`

Inheritance diagram for orxonox::Camera:

List of all members.

## Public Member Functions

| Camera (BaseObject *creator)
bool | getDrag () const
bool | hasFocus ()
void | releaseFocus ()
void | requestFocus ()
void | setConfigValues ()
| Function to collect the SetConfigValue-macro calls.
void | setDrag (bool bDrag)
virtual void | tick (float dt)
| Gets called every frame.
virtual | ~Camera ()

## Private Member Functions

void | configvaluecallback_changedNearClipDistance ()
void | removeFocus ()
void | setFocus ()

## Private Attributes

bool | bDrag_
bool | bHasFocus_
Ogre::Camera * | camera_
Ogre::SceneNode * | cameraNode_
float | nearClipDistance_

## Friends

class | CameraManager

## Constructor & Destructor Documentation

orxonox::Camera::Camera | ( | BaseObject * | creator | ) |

References orxonox::WorldEntity::attachNode(), bDrag_, bHasFocus_, camera_, cameraNode_, configvaluecallback_changedNearClipDistance(), orxonox::Scene::getRootSceneNode(), orxonox::BaseObject::getScene(), orxonox::Scene::getSceneManager(), orxonox::getUniqueNumberString(), nearClipDistance_, RegisterObject, setConfigValues(), orxonox::Synchronisable::setObjectMode(), and ThrowException.

orxonox::Camera::~Camera | ( |  | ) | `[virtual]`

References bDrag_, camera_, cameraNode_, orxonox::WorldEntity::detachNode(), orxonox::BaseObject::getScene(), orxonox::Scene::getSceneManager(), orxonox::BaseObject::isInitialized(), and releaseFocus().

## Member Function Documentation

void orxonox::Camera::configvaluecallback_changedNearClipDistance | ( |  | ) | `[private]`

References camera_, and nearClipDistance_.

Referenced by Camera(), and setConfigValues().

bool orxonox::Camera::getDrag | ( |  | ) | const`[inline]`

bool orxonox::Camera::hasFocus | ( |  | ) | `[inline]`

void orxonox::Camera::releaseFocus | ( |  | ) |

References orxonox::CameraManager::getInstance(), and orxonox::CameraManager::releaseFocus().

Referenced by ~Camera().

void orxonox::Camera::removeFocus | ( |  | ) | `[private]`

what to do when camera loses focus (do not request focus in this function!!) this is called by the CameraManager singleton class to notify the camera

References bHasFocus_.

Referenced by orxonox::CameraManager::releaseFocus().

void orxonox::Camera::requestFocus | ( |  | ) |

References orxonox::CameraManager::getInstance(), and orxonox::CameraManager::requestFocus().

Referenced by orxonox::ControllableEntity::startLocalHumanControl().

void orxonox::Camera::setConfigValues | ( |  | ) |

Function to collect the SetConfigValue-macro calls.

Reimplemented from orxonox::OrxonoxClass.

References configvaluecallback_changedNearClipDistance(), nearClipDistance_, and SetConfigValue.

Referenced by Camera().

void orxonox::Camera::setDrag | ( | bool | bDrag | ) |

References orxonox::WorldEntity::attachNode(), bDrag_, cameraNode_, orxonox::WorldEntity::detachNode(), orxonox::WorldEntity::getWorldOrientation(), and orxonox::WorldEntity::getWorldPosition().

Referenced by orxonox::CameraPosition::attachCamera().

void orxonox::Camera::setFocus | ( |  | ) | `[private]`

References bHasFocus_, camera_, orxonox::CameraManager::getInstance(), and orxonox::CameraManager::useCamera().

Referenced by orxonox::CameraManager::requestFocus().

void orxonox::Camera::tick | ( | float | dt | ) | `[virtual]`

Gets called every frame.

Parameters:

  | dt | The time since the last frame in seconds

Implements orxonox::Tickable.

References bDrag_, cameraNode_, orxonox::WorldEntity::getWorldOrientation(), orxonox::WorldEntity::getWorldPosition(), SUPER, and orxonox::MT_Type::Vector3.

## Friends And Related Function Documentation

friend class CameraManager`[friend]`

## Member Data Documentation

bool orxonox::Camera::bDrag_`[private]`

Referenced by Camera(), setDrag(), tick(), and ~Camera().

bool orxonox::Camera::bHasFocus_`[private]`

Referenced by Camera(), removeFocus(), and setFocus().

Ogre::Camera* orxonox::Camera::camera_`[private]`

Referenced by Camera(), configvaluecallback_changedNearClipDistance(), setFocus(), and ~Camera().

Ogre::SceneNode* orxonox::Camera::cameraNode_`[private]`

Referenced by Camera(), setDrag(), tick(), and ~Camera().

float orxonox::Camera::nearClipDistance_`[private]`

Referenced by Camera(), configvaluecallback_changedNearClipDistance(), and setConfigValues().

The documentation for this class was generated from the following files:

- src/orxonox/objects/worldentities/Camera.h
- src/orxonox/objects/worldentities/Camera.cc